SystemOrganization addCategory: #'Tank Game'!

Morph subclass: #Bullet
	instanceVariableNames: 'bulletX bulletY isAlive gravity xVel yVel timeAlive xMin xMax yMax'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tank Game'!

!Bullet commentStamp: '<historical>' prior: 0!
A Bullet is xxxxxxxxx.

Instance Variables
	bulletX:		<Object>
	bulletY:		<Object>
	gravity:		<Object>
	isAlive:		<Object>
	timeAlive:		<Object>
	xVel:		<Object>
	yVel:		<Object>

bulletX
	- xxxxx

bulletY
	- xxxxx

gravity
	- xxxxx

isAlive
	- xxxxx

timeAlive
	- xxxxx

xVel
	- xxxxx

yVel
	- xxxxx
!

!Bullet methodsFor: 'initialize' stamp: 'GKB 7/16/2014 22:11'!
bulletX: x bulletY: y angle: ang speed:spd

	bulletX := x.
	bulletY :=y.

	xVel := spd * (ang cos).
	yVel := spd * (ang sin).
	
	isAlive := true.
	gravity := 0.005.
	timeAlive := 0.
	
	self changed.
! !

!Bullet methodsFor: 'modifying' stamp: 'GKB 7/16/2014 02:21'!
collision
	isAlive := false.
	self changed.! !

!Bullet methodsFor: 'as yet unclassified' stamp: 'GKB 7/16/2014 23:15'!
drawOn: aCanvas

	| fillRect |
	
	(isAlive) ifTrue: [  
				fillRect := (bounds origin) extent: (20@20).
				aCanvas fillOval: fillRect color: color.
				self position: (
								(bulletX + ((self width )/2))@
								(bulletY + ((self height)/2))).].! !

!Bullet methodsFor: 'modifying' stamp: 'GKB 7/16/2014 22:10'!
fire

	isAlive := true.

"	(isAlive) ifTrue: [ 
		bulletX := bulletX + (xVel*timeAlive).
		bulletY := bulletY + (yVel*timeAlive) + (0.5 * gravity* timeAlive * timeAlive).
		self position: (bulletX@bulletY).		
		timeAlive := timeAlive + (self stepTime).
]."
	self changed.! !

!Bullet methodsFor: 'modifying' stamp: 'GKB 7/16/2014 22:13'!
isAlive
	^isAlive.! !

!Bullet methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 02:17'!
step
| x y |

x := bulletX + (xVel*timeAlive).
y := bulletY + (yVel*timeAlive) + (0.5 * gravity* timeAlive * timeAlive).

	(isAlive) ifTrue:[
		((x > xMax) | (x < xMin) | (y > yMax) )
		"(timeAlive > 150)"
		ifTrue: [
				isAlive := false.
				self stopStepping.
				self delete. 
				Transcript show: 'Bullet Left Playing Field!!'.
				Transcript cr.
				  ]
		ifFalse: [ 
				bulletX := x.
				bulletY := y.
				self position: (bulletX@bulletY).
				timeAlive := timeAlive + (self stepTime).].
		]
	ifFalse: [ 
				self stopStepping.
				self delete. 
				Transcript show: 'Bullet Hit an Object'.
				Transcript cr. ].
			
	self changed.
		
"	Transcript show: xMax .
	Transcript cr."
	
	
	! !

!Bullet methodsFor: 'as yet unclassified' stamp: 'GKB 7/16/2014 01:48'!
stepTime
^ 1! !

!Bullet methodsFor: 'initialize' stamp: 'GKB 7/16/2014 22:18'!
xMin:xMn xMax:xMx yMax:yMx

	xMin := xMn.
	xMax := xMx.
	yMax := yMx.

	bulletX := 0.
	bulletY :=0.

	xVel := 0.
	yVel := 0.
	
	isAlive := false.
	gravity := 0.005.
	timeAlive := 0.
	
	self changed.
! !

Morph subclass: #GameBoard
	instanceVariableNames: 'keyBindings actionList hori vert spinR tank bullet power angle playerOne playerTwo client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tank Game'!

!GameBoard commentStamp: 'GKB 7/13/2014 17:50' prior: 0!
I created this as a placeholder for the player input handler. Open the transcript to view the function flow. The temporary gameboard morph is in the top left, you can hover over that and start accpeting keyboard inputs. You can also click in the morph to hold keyboard focus when the mouse leaves. You can also call rebindKeys to rebind player functions and keys.
!

!GameBoard methodsFor: 'playerActions' stamp: 'GKB 7/17/2014 18:03'!
decreasePower

	| playerOnePower |
	
	playerOnePower := 0.

	playerOnePower := playerOne getTank getPower.

	(playerOnePower <= 0)
		ifTrue: [ playerOne getTank setPower: 0. ]
		ifFalse: [ playerOne getTank setPower: (playerOnePower - 1). ].
		
Transcript show: ('Decrease Power to ',((playerOne getTank getPower) asString)) .
Transcript cr.! !

!GameBoard methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 18:21'!
did: morph1 collideWith: morph2
"basic collision detection using rectangels"
 
	| a b c d e f g h |

	a := (morph1 position x).
	b := (morph1 position y).
	c := ((morph1 position x) + (morph1 width)).
	d := ((morph1 position y) + (morph1 height)).
	
	e := (morph2 position x).
	f := (morph2 position y).
	g := ((morph2 position x) + (morph2 width)).
	h := ((morph2 position y) + (morph2 height)).
	
	( (a < g) & (c > e) & (b < h) & (d > f))
		ifTrue: [ 
				 "Transcript show: 'collision!!'."
				 "Transcript cr."
				 ^true. ]
		ifFalse:[ ^false].
		
	! !

!GameBoard methodsFor: 'playerActions' stamp: 'GKB 7/17/2014 18:00'!
fire

Transcript show: 'Fire gun'.
Transcript cr.
self startStepping. 


(playerOne getBullet isAlive) 
	ifFalse: [ 
 		(playerOne getBullet) bulletX: ((playerOne getTank getX)+((playerOne getTank width)/2))  
							    bulletY: ((playerOne getTank getY)) 
							    angle: (-1)*(playerOne getTank getAngle degreesToRadians) 
							    speed: (0.3*(playerOne getTank getPower)/100).
		self addMorph: (playerOne getBullet).] 
	ifTrue: [ 
		Transcript show: 'No Ammo!!'.
		Transcript cr.]
! !

!GameBoard methodsFor: 'playerInput' stamp: 'GKB 7/14/2014 19:12'!
handleKeystroke: anEvent
| keyValue |

keyValue := keyBindings at: (anEvent keyValue)  ifAbsent: nil.
Transcript show: 'Keyboard Input: ', (anEvent keyCharacter) asString, '. Ascii Value: ', (anEvent keyValue) asString.
Transcript cr.

keyValue = #moveLeft
	ifTrue: [self moveLeft].
keyValue = #moveRight
	ifTrue: [self moveRight].
keyValue =#rotateCW
	ifTrue: [self rotateCW].
keyValue = #rotateCCW
	ifTrue: [self rotateCCW].
keyValue =#increasePower
	ifTrue: [self increasePower].
keyValue = #decreasePower
	ifTrue: [self decreasePower].
keyValue = #fire
	ifTrue: [self fire].
keyValue = nil
	ifTrue: [Transcript show: 'No action bound to this key.'.
			Transcript cr.].! !

!GameBoard methodsFor: 'playerInput' stamp: 'GKB 7/13/2014 17:31'!
handlesMouseDown: anEvent

	^true! !

!GameBoard methodsFor: 'playerInput' stamp: 'GKB 7/13/2014 13:11'!
handlesMouseOver: anEvent

	^true! !

!GameBoard methodsFor: 'playerActions' stamp: 'GKB 7/17/2014 18:04'!
increasePower

"(power >= 100)
		ifTrue: [ power := 100. ]
		ifFalse: [ power := power + 1. ].
		
Transcript show: ('Increase Power to ',(power asString)) .
Transcript cr."

| playerOnePower |
	
	playerOnePower := 0.

	playerOnePower := playerOne getTank getPower.

	(playerOnePower >= 100)
		ifTrue: [ playerOne getTank setPower: 100. ]
		ifFalse: [ playerOne getTank setPower: (playerOnePower + 1). ].
		
Transcript show: ('Increase Power to ',((playerOne getTank getPower) asString)) .
Transcript cr.! !

!GameBoard methodsFor: 'initialize' stamp: 'CaseyPiper 7/18/2014 01:43'!
initialize
	super initialize.
	
	keyBindings := Dictionary new.
		
	keyBindings at:($a asciiValue)   put: #moveLeft. 
	keyBindings at:($d asciiValue) put: #moveRight. 
	keyBindings at:($j asciiValue)   put: #rotateCCW. 
	keyBindings at:($l asciiValue)   put: #rotateCW. 
	keyBindings at:($i asciiValue)   put: #increasePower. 
	keyBindings at:($k asciiValue)   put: #decreasePower. 	
	keyBindings at:32   put: #fire. 			"32 = 	spaceBar"
	
	actionList := Set new.
	actionList := #(	'moveLeft' 'moveRight' 'rotateCW' 'rotateCCW' 'increasePower' 'decreasePower' 'fire').
		
	self height: 720.
	self width: 1200.
	self color: Color lightGray.
	hori := 3.
	vert := 3.
	spinR := 1.
	
	"Old Structure where the gamboard has tanka nd bullet objects"
	"A few methods need to be slightly modified to reimplement this"
	"tank := TankMorph new.
	tank position:(100@600).
	self addMorph:  tank."
	
	"self openInWindowLabeled:'Tank Game'."
	
	"bullet := (Bullet new xMin: (self position x) xMax: ((self position x) + 1200) yMax: ((self position y) + 720)).
	power := 50.
	angle := 45."
	
	"New structure where a player object has a tank and a bullet"
	playerOne := Player new 
					xMin: (self position x) 
					xMax: ((self position x) + 1200) 
					yMax: ((self position y) + 720)  
					tankX: 100 
					tankY: 600. 				
	self addMorph: (playerOne getTank). 
	self addMorph: (playerOne getBullet). 
	
	playerTwo := Player new 
					xMin: (self position x) 
					xMax: ((self position x) + 1200) 
					yMax: ((self position y) + 720)  
					tankX: self width - playerOne getTank getX - 100
					tankY: 600. 
	self addMorph: (playerTwo getTank). 
	self addMorph: (playerTwo getBullet). 

	client := Client new.
			"uncomment to start network
	client start: 12346.
	client setPlayerX: 800.
	"
	self openInWorld.! !

!GameBoard methodsFor: 'playerInput' stamp: 'JonathanMark 7/14/2014 20:28'!
mouseDown: anEvent

"game holds keyboard focus of the user clicks"
 anEvent hand newKeyboardFocus: self.



anEvent redButtonPressed
	ifTrue: [
			Transcript show: 'Red Mouse Button Click'.
			Transcript cr].
anEvent yellowButtonPressed
	ifTrue: [Transcript show: 'Yellow Mouse Button Click'.
			Transcript cr].
self changed.
! !

!GameBoard methodsFor: 'playerInput' stamp: 'GKB 7/13/2014 15:28'!
mouseEnter: anEvent
"anEvent hand newKeyboardFocus: self"
"mouseIn := true."! !

!GameBoard methodsFor: 'playerInput' stamp: 'GKB 7/13/2014 15:28'!
mouseLeave: anEvent
"anEvent hand newKeyboardFocus: nil"
"mouseIn := false."! !

!GameBoard methodsFor: 'playerActions' stamp: 'CaseyPiper 7/17/2014 23:45'!
moveLeft

| xStep yStep |

	xStep := -10.
	yStep := 0.

Transcript show: 'Move Tank Right'.
Transcript cr.
"tank position: (tank position + (10@0))"



playerOne getTank setX: (playerOne getTank getX + xStep) setY:  (playerOne getTank getY + yStep).

client updateData: playerOne.! !

!GameBoard methodsFor: 'playerActions' stamp: 'CaseyPiper 7/17/2014 23:48'!
moveRight

	| xStep yStep |

	xStep := 10.
	yStep := 0.

Transcript show: 'Move Tank Right'.
Transcript cr.
"tank position: (tank position + (10@0))"



playerOne getTank setX: (playerOne getTank getX + xStep) setY:  (playerOne getTank getY + yStep).

client updateData: playerOne.! !

!GameBoard methodsFor: 'playerInput' stamp: 'GKB 7/14/2014 18:53'!
rebindKeys

	| keyToChange changeToThis |
	
	keyToChange := 0.
	changeToThis := 0.
						
	keyToChange := UIManager default 
						chooseFrom: actionList 
						lines: #(2 4 6) 
						message: 'Which action would you like to rebind?'
						title: 'Rebind keys'.
	
						
	(keyToChange = 0)
		ifFalse: [ 
				
				(keyBindings keysAndValuesDo: 
				[ :key :val | val = (actionList at: keyToChange)  
					ifTrue:[changeToThis := UIManager default 
											request: 'Bind ', (actionList at: keyToChange),' to what key? It only takes the first charater' 
											initialAnswer: key asCharacter. 
							(changeToThis isNil) ifFalse: [ keyBindings removeKey: key]. 
						    ]  
				]).

				(changeToThis isNil) 
				ifFalse: [ 
					keyBindings at: (changeToThis first asciiValue) put:(actionList at: keyToChange).
						]
				].
	! !

!GameBoard methodsFor: 'playerActions' stamp: 'GKB 7/17/2014 18:07'!
rotateCCW

"(angle+1 >= 360)
		ifTrue: [ angle := angle + 1 - 360. ]
		ifFalse: [ angle := angle + 1. ].
		
		tank setAngle: angle.
		self changed.
Transcript show: ('Rotate Tank Counterclockwise to ',(angle asString)) .
Transcript cr."

((playerOne getTank getAngle)+1 >= 360)
		ifTrue: [ playerOne getTank setAngle:((playerOne getTank getAngle) + 1 - 360). ]
		ifFalse: [ playerOne getTank setAngle:((playerOne getTank getAngle) + 1). ].

	"tank setAngle: angle."
	self changed.
Transcript show: ('Rotate Tank Counterclockwise to ',((playerOne getTank getAngle) asString)) .
Transcript cr.
! !

!GameBoard methodsFor: 'playerActions' stamp: 'GKB 7/17/2014 18:07'!
rotateCW

((playerOne getTank getAngle) <= 0)
		ifTrue: [ playerOne getTank setAngle:((playerOne getTank getAngle) - 1 + 360). ]
		ifFalse: [ playerOne getTank setAngle:((playerOne getTank getAngle) - 1). ].

	"tank setAngle: angle."
	self changed.
Transcript show: ('Rotate Tank Clockwise to ',((playerOne getTank getAngle) asString)) .
Transcript cr.
! !

!GameBoard methodsFor: 'run' stamp: 'CaseyPiper 7/18/2014 01:39'!
step

	"tank position: (tank position + (hori@vert)).
	( (tank position x + tank width) > (self position x + self width) ) ifTrue:
		[ hori := (hori abs) * -1 ].
	( (tank position y + tank height) > (self position y + self height) ) ifTrue:
		[ vert  := (vert abs) * -1 ].
	( tank position x < (self position x) ) ifTrue:
		[ hori := hori abs ].
	( tank position y < (self position y) ) ifTrue:
		[ vert := vert abs ]."
	
	"tank increaseTurretAngle: 5."
	
	
	
	"uncomment to start network"
"	((playerTwo getTank getX) = client getPlayerX) ifFalse:  [ 
		playerTwo getTank setX: (self width - client getPlayerX) setY:  playerTwo getTank getY.
	]."

	(playerOne getBullet isAlive)
	ifTrue: [ 
		"Friendly Fire"
			(self did: (playerOne getBullet) collideWith: (playerOne getTank)) ifTrue: [ "Transcript show: 'Player 1 bullet hit Player 1'. Transcript cr. ""bullet collision." ]. 
		"Enemy FIre"
			(self did: (playerOne getBullet) collideWith: (playerTwo getTank)) ifTrue: [ Transcript show: 'Player 1 bullet hit Player 2'. Transcript cr. (playerOne getBullet collision ). ]
			].! !

!GameBoard methodsFor: 'run' stamp: 'GKB 7/17/2014 01:29'!
stepTime
^1! !

Morph subclass: #Tank
	instanceVariableNames: 'positionX positionY angle power'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tank Game'!

!Tank methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 17:32'!
drawOn: aCanvas
	| fillRect turretStart turretEndX turretEndY |
	fillRect := (bounds origin + (20@20)) extent: (50@30).
	aCanvas fillRectangle: fillRect color: color.
	turretStart := (fillRect leftCenter + (10@0)).
	
	turretEndX := turretStart x + (20 * (angle degreesToRadians cos)).
	turretEndY := turretStart y - (20 * (angle degreesToRadians sin)).
	
	aCanvas line: turretStart to: (turretEndX@turretEndY) width: 3 color: Color black.! !

!Tank methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 17:57'!
getAngle
	^angle
	! !

!Tank methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 17:57'!
getPower
	^power
	! !

!Tank methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 17:56'!
getX
	^positionX
	! !

!Tank methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 17:57'!
getY
	^positionY
	! !

!Tank methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 18:12'!
initialize
	super initialize.
	self color: Color blue.
	self bounds: (0@0 extent: 90@70).
	
	positionX := 0.
	positionY := 0.
	angle := 45.
	power := 50.
	! !

!Tank methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 18:08'!
setAngle: thisAngle
 angle := thisAngle rounded.! !

!Tank methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 17:53'!
setPower: thisPower
 power := thisPower.! !

!Tank methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 17:48'!
setX:x setY:y
	positionX := x.
	positionY := y.
	
	self position: (x@y).
	! !

Morph subclass: #TankMorph
	instanceVariableNames: 'turretAngle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tank Game'!

!TankMorph commentStamp: '<historical>' prior: 0!
A TankMorph is xxxxxxxxx.

Instance Variables
	turretAngle:		<Object>

turretAngle
	- xxxxx
!

!TankMorph methodsFor: 'drawing' stamp: 'GKB 7/17/2014 02:27'!
drawOn: aCanvas
	| fillRect turretStart turretEndX turretEndY |
	fillRect := (bounds origin + (20@20)) extent: (50@30).
	aCanvas fillRectangle: fillRect color: color.
	turretStart := (fillRect leftCenter + (10@0)).
	
	turretEndX := turretStart x + (20 * (turretAngle degreesToRadians cos)).
	turretEndY := turretStart y - (20 * (turretAngle degreesToRadians sin)).
	
	aCanvas line: turretStart to: (turretEndX@turretEndY) width: 3 color: Color black.! !

!TankMorph methodsFor: 'update' stamp: 'JonathanMark 7/13/2014 18:00'!
increaseTurretAngle: amount
	"comment stating purpose of message"

	turretAngle := turretAngle + (amount degreesToRadians).! !

!TankMorph methodsFor: 'initialize' stamp: 'JonathanMark 7/13/2014 18:00'!
initialize
	super initialize.
	self color: Color blue.
	self bounds: (0@0 extent: 90@70).
	
	turretAngle := 180 degreesToRadians.
	! !

!TankMorph methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 02:24'!
setAngle: angle
 turretAngle:= angle.! !

Object subclass: #Client
	instanceVariableNames: 'socket playerX'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tank Game'!

!Client commentStamp: '<historical>' prior: 0!
A Client is the TCP client of the game.
!

!Client methodsFor: 'as yet unclassified' stamp: 'CaseyPiper 7/18/2014 00:55'!
getPlayerX
	^playerX! !

!Client methodsFor: 'initialization' stamp: 'CaseyPiper 7/18/2014 00:45'!
initialize
   Smalltalk garbageCollect.
   playerX := 0.! !

!Client methodsFor: 'instructions' stamp: 'CaseyPiper 7/17/2014 22:48'!
send: aByteArray
	| bytesSent |
[ 
	bytesSent := socket sendData: aByteArray.
	bytesSent <= 0 ifTrue: [ Transcript show: 'no data sent'; cr. 
			socket closeAndDestroy.
		]
] forkAt: Processor userBackgroundPriority.! !

!Client methodsFor: 'as yet unclassified' stamp: 'CaseyPiper 7/18/2014 00:45'!
setPlayerX: aLocation
	playerX := aLocation.! !

!Client methodsFor: 'initialization' stamp: 'CaseyPiper 7/17/2014 20:51'!
start
    | socket bytesToSend sendBuf receiveBuf done bytesSent bytesReceived packetsSent 
packetsReceived t |

   Smalltalk garbageCollect.

   Transcript show: 'starting client/server TCP test'; cr.
   Transcript show: 'initializing network ... '.
   Transcript show: 'ok'; cr.

   socket := Socket newTCP.
   socket connectTo: (NetNameResolver addressForName: 'localhost') port: 12345.
   [
      socket waitForConnectionFor: 10.
      Transcript show: 'client endpoint created'; cr.
      bytesToSend := 1000000.
      sendBuf := String new: 4000 withAll: $x.
      receiveBuf := String new: 50000.
      done := false.
      bytesSent := bytesReceived := packetsSent := packetsReceived := 0.

      t := Time millisecondsToRun:[[done] whileFalse: 
          [(socket sendDone and: [bytesSent < bytesToSend]) ifTrue: 
             [ packetsSent := packetsSent + 1.
               bytesSent := bytesSent + (socket sendData: sendBuf)].
               socket dataAvailable ifTrue: 
                  [ packetsReceived := packetsReceived + 1.
                    bytesReceived := bytesReceived + (socket receiveDataInto: receiveBuf) ].
               done := bytesSent >= bytesToSend ].
           [bytesReceived < bytesToSend] whileTrue: 
               [ socket dataAvailable ifTrue: 
                   [ packetsReceived := packetsReceived + 1.
                     bytesReceived := bytesReceived + (socket receiveDataInto: receiveBuf)]]].
       socket closeAndDestroy.
      Transcript show: 'remoteClient TCP test done; time = ' , t printString; cr.
      Transcript
          show: packetsSent printString , ' packets, ' , bytesSent printString , 
                   ' bytes sent (' , (bytesSent * 1000 // t) printString , 
                   ' bytes/sec)'; cr.
      Transcript
          show: packetsReceived printString , ' packets, ' ,
          bytesReceived printString , ' bytes received (' , 
         (bytesReceived * 1000 // t) printString , ' bytes/sec)'; cr.

  ] forkAt: Processor userBackgroundPriority.! !

!Client methodsFor: 'initialization' stamp: 'CaseyPiper 7/18/2014 01:33'!
start: port
    | bytesToSend sendBuf receiveBuf done bytesSent bytesReceived packetsSent 
packetsReceived  |

Smalltalk garbageCollect.

Transcript show: 'starting client'; cr.
Transcript show: 'initializing network ... '.
Transcript show: 'ok'; cr.

socket := Socket newTCP.
socket connectTo: (NetNameResolver addressForName: 'localhost') port: port.
[
      socket waitForConnectionFor: 10.
      Transcript show: 'client endpoint created'; cr.
      bytesToSend := 1000000.
      sendBuf := String new: 4000 withAll: $x.
      receiveBuf := String new: 50000.
      done := false.
      bytesSent := bytesReceived := packetsSent := packetsReceived := 0.

	
	[socket isConnected] whileTrue: [ 
			socket dataAvailable ifTrue: [ 
					receiveBuf := String new: 4000.
					socket receiveDataInto: receiveBuf.
					receiveBuf asNumber = 0 ifFalse: [ 
						self setPlayerX: (receiveBuf asNumber).
					].
					Transcript cr; show: 'Received something';cr.
				 ].
		 ].

"	[done] whileFalse: 
	[
		(socket sendDone and: [bytesSent < bytesToSend]) ifTrue: 
		[
			packetsSent := packetsSent + 1.
			bytesSent := bytesSent + (socket sendData: sendBuf)
		].
		socket dataAvailable ifTrue: 
		[
			packetsReceived := packetsReceived + 1.
			bytesReceived := bytesReceived + (socket receiveDataInto: receiveBuf)
		].
		done := bytesSent >= bytesToSend
	].
	[bytesReceived < bytesToSend] whileTrue: 
	[
		socket dataAvailable ifTrue: 
		[
			packetsReceived := packetsReceived + 1.
			bytesReceived := bytesReceived + (socket receiveDataInto: receiveBuf)
		]
	]."
"	socket closeAndDestroy."
	Transcript show: 'remoteClient TCP test done;' ; cr.

] forkAt: Processor userBackgroundPriority.! !

!Client methodsFor: 'as yet unclassified' stamp: 'CaseyPiper 7/18/2014 01:41'!
updateData: aPlayer
	| bytesSent aByteArray |
	aByteArray := aPlayer getTank getX asString.
[
	socket isNil ifFalse: [ 
	bytesSent := socket sendData: aByteArray.
	bytesSent <= 0 ifTrue: [ Transcript show: 'no data sent'; cr. 
			socket closeAndDestroy.
		]
	]
] forkAt: Processor userBackgroundPriority.! !

Object subclass: #Player
	instanceVariableNames: 'bullet tank health'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tank Game'!

!Player methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 17:49'!
getBullet
	^bullet! !

!Player methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 17:49'!
getTank
	^tank! !

!Player methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 17:44'!
isAlive
	(health > 0)
		ifTrue: [ ^true ]
		ifFalse: [ ^false ].! !

!Player methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 17:45'!
xMin:xMn xMax:xMx yMax:yMx tankX:tX tankY: tY
	
	health := 100.
	tank := Tank new setX: tX setY: tY.
	bullet := Bullet new xMin:xMn xMax:xMx yMax:yMx.
! !

Object subclass: #Server
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tank Game'!

!Server commentStamp: '<historical>' prior: 0!
A Server is the server for the game that sends locations of tanks back to the otehr client.
!

!Server methodsFor: 'accessing' stamp: 'CaseyPiper 7/18/2014 01:32'!
initialize
    | P1Socket P2Socket P1Client P2Client P1Buf P2Buf n1 n2 P1Update P2Update|

Transcript show: 'initializing sockets ... '.
Transcript show: 'ok'; cr.
P1Socket := Socket newTCP.
P1Socket listenOn: 12345 backlogSize: 5 interface: (NetNameResolver addressForName: 'localhost').
P1Update := P2Update := nil.

Transcript show: 'server endpoint1 created -- run client test in other image'; cr.

P1Buf := ByteArray new: 4000.
[
	P1Client := P1Socket waitForAcceptFor: 10.
	[
		P1Client isConnected
	] whileTrue: 
	[
		P1Client dataAvailable ifTrue: 
		[
			P1Buf := String new: 4000.
			n1 := P1Client receiveDataInto: P1Buf.
			Transcript show: P1Buf; cr.	
			P1Update := P1Buf.
		].
		P2Update = nil ifFalse: [ 
			P1Client sendData: P2Update.
			P2Update := nil.
		 ]
	].
	P1Client closeAndDestroy.
	P1Socket closeAndDestroy.
	Transcript cr; show: 'server endpoint1 destroyed'; cr.

] forkAt: Processor userBackgroundPriority.

Transcript show: 'server endpoint2 created -- run client test in other image'; cr.

P2Socket := Socket newTCP.
P2Socket listenOn: 12346 backlogSize: 5 interface: (NetNameResolver addressForName: 'localhost').

P2Buf := String new: 4000.
[
	P2Client := P2Socket waitForAcceptFor: 10.
	[
		P2Client isConnected
	] whileTrue: 
	[
		P2Client dataAvailable ifTrue: 
		[
			P2Buf := String new: 4000.
			n2 := P2Client receiveDataInto: P2Buf.
			Transcript show: P2Buf; cr.	
			P2Update := P2Buf.
		].
		P1Update = nil ifFalse: [ 
			P2Client sendData: P1Update.
			P1Update := nil.
		 ].
	].
	P2Client closeAndDestroy.
	P2Socket closeAndDestroy.
	Transcript cr; show: 'server endpoint2 destroyed'; cr.

] forkAt: Processor userBackgroundPriority.
! !

Object subclass: #TestClient3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tank Game'!

!TestClient3 commentStamp: '<historical>' prior: 0!
A TestClient3 is a client for sending/receiving messages.
!

!TestClient3 methodsFor: 'accessing' stamp: 'CaseyPiper 7/14/2014 00:39'!
start
    | socket bytesToSend sendBuf receiveBuf done bytesSent bytesReceived packetsSent 
packetsReceived t |

   Smalltalk garbageCollect.

   Transcript show: 'starting client/server TCP test'; cr.
   Transcript show: 'initializing network ... '.
   Transcript show: 'ok'; cr.

   socket := Socket newTCP.
   socket connectTo: (NetNameResolver addressForName: 'localhost') port: 12345.
   [
      socket waitForConnectionFor: 10.
      Transcript show: 'client endpoint created'; cr.
      bytesToSend := 1000000.
      sendBuf := String new: 4000 withAll: $x.
      receiveBuf := String new: 50000.
      done := false.
      bytesSent := bytesReceived := packetsSent := packetsReceived := 0.

      t := Time millisecondsToRun:[[done] whileFalse: 
          [(socket sendDone and: [bytesSent < bytesToSend]) ifTrue: 
             [ packetsSent := packetsSent + 1.
               bytesSent := bytesSent + (socket sendData: sendBuf)].
               socket dataAvailable ifTrue: 
                  [ packetsReceived := packetsReceived + 1.
                    bytesReceived := bytesReceived + (socket receiveDataInto: receiveBuf) ].
               done := bytesSent >= bytesToSend ].
           [bytesReceived < bytesToSend] whileTrue: 
               [ socket dataAvailable ifTrue: 
                   [ packetsReceived := packetsReceived + 1.
                     bytesReceived := bytesReceived + (socket receiveDataInto: receiveBuf)]]].
       socket closeAndDestroy.
      Transcript show: 'remoteClient TCP test done; time = ' , t printString; cr.
      Transcript
          show: packetsSent printString , ' packets, ' , bytesSent printString , 
                   ' bytes sent (' , (bytesSent * 1000 // t) printString , 
                   ' bytes/sec)'; cr.
      Transcript
          show: packetsReceived printString , ' packets, ' ,
          bytesReceived printString , ' bytes received (' , 
         (bytesReceived * 1000 // t) printString , ' bytes/sec)'; cr.

  ] forkAt: Processor userBackgroundPriority.! !
